<?
/*
Copyright (c) 2004 by Petr Bohac
---------------------------
This file is part of VerliAdmin.

VerliAdmin is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

VerliAdmin is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with VerliAdmin; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//Get browser type
IF($_COOKIE['brwsr_tp'] == "") {
	$time = Time() + 31536000;
	//Opera browser
	IF(EregI("opera.[1-9]", $_SERVER['HTTP_USER_AGENT']))
		{SetCookie("brwsr_tp", "Opera", $time);$_COOKIE['brwsr_tp'] = "Opera";}
	//MSIE browser
	ELSEIF(EregI("msie.[1-9]", $_SERVER['HTTP_USER_AGENT']))
		{SetCookie("brwsr_tp", "MSIE", $time); $_COOKIE['brwsr_tp'] = "MSIE";}
	//Netscape or mozilla
	ELSEIF(EregI("rv:1\.[1-9]|netscape", $_SERVER['HTTP_USER_AGENT']))
		{SetCookie("brwsr_tp", "Mozilla", $time); $_COOKIE['brwsr_tp'] = "Mozilla";}
	//Some other
	ELSE
		{SetCookie("brwsr_tp", "Other", $time); $_COOKIE['brwsr_tp'] = "Other";}
}

//---------------------------------------------------------------------
//Logaritmic size of bars in stats page
FUNCTION CountStatBar($max, $value) {
	$res = 5;
	$der = 80;
	$size = 150;

	$width = Ceil($size*((Log($res + $der*$value/$max)-Log($res))/(Log($res+$der)-Log($res))));

	RETURN $width;
}

//---------------------------------------------------------------------

FUNCTION CryptPwd($password) {
	$num1 = Rand(97, 122);
	$num2 = Rand(65, 90);
	$password = Crypt($password, Chr($num1).Chr($num2));

	RETURN $password;
}

//---------------------------------------------------------------------

FUNCTION EscapeTime($time_format) {
	$time_format = Ereg_Replace("[A-Za-z]", "\0", $time_format);
	RETURN $time_format;
}

//---------------------------------------------------------------------
//Fetch classes from "##|##|##|##|##" format string
FUNCTION FetchClass($setup_class) {
	$class = Explode("|", $setup_class);
	$class[10] = $class[5];
	$class[5] = $class[4];
	$class[4] = $class[3];
	$class[3] = $class[2];
	$class[2] = $class[1];
	$class[1] = $class[0];
	
	RETURN $class;
}

//---------------------------------------------------------------------
//Convert integer value of IP to IPv4
FUNCTION Get_IP_From_Range($range) {
	$range = $range / 16777216; // 16777216 = 256^3
	$a = (int)$range;
	$range -= $a;
	
	$range = $range * 256;
	$b = (int)$range;
	$range -= $b;
	
	$range = $range * 256;
	$c = (int)$range;
	$range -= $c;
	
	$d = $range * 256;
	
	$ip = $a.".".$b.".".$c.".".$d;

	RETURN $ip;
}

//---------------------------------------------------------------------
//Return name of class
FUNCTION GetClassName($class) {
	IF($class == 0){$class_name = "text_guest";}
	ELSEIF($class == 1){$class_name = "text_reg";}
	ELSEIF($class == 2){$class_name = "text_vip";}
	ELSEIF($class == 3){$class_name = "text_op";}
	ELSEIF($class == 4){$class_name = "text_chief_op";}
	ELSEIF($class == 5){$class_name = "text_admin";}
	ELSEIF($class == 10){$class_name = "text_master";}
	
	RETURN $class_name;
}

//---------------------------------------------------------------------

FUNCTION GetMicroTime($time = 0) {
	IF(!$time)
		{$time = MicroTime();}
	List($usec, $sec) = Explode(" ", $time); 
	RETURN ((float)$usec + (float)$sec); 
}

//---------------------------------------------------------------------
//Log actions to file
FUNCTION LogFile($nick, $class, $action, $logaction) {
	GLOBAL $setup;
//	Include "config.php";

	$log = $setup['log_format'];
	$log = EregI_Replace("%time%", Date($setup['time_format']), $log);
	$log = EregI_Replace("%date%", Date($setup['date_format']), $log);
	$log = EregI_Replace("%nick%", $nick, $log);
	$log = EregI_Replace("%class%", $class, $log);
	$log = EregI_Replace("%ip%", $_SERVER['REMOTE_ADDR'], $log);
	$log = EregI_Replace("%host%", GetHostByAddr($_SERVER['REMOTE_ADDR']), $log);
	$log = EregI_Replace("%action%", $action, $log);
	
	//If loging by action is enabled log to file by action name
	IF(EregI("%logfileaction%", $log)) {
		$write = EregI_Replace("%logfileaction%", "", $log);
		$write = EregI_Replace("%logfilenick%", "", $write);
		$file = @FOpen($setup['log_dir'].$logaction.".log", "a+");
		@FWrite($file, $write."\r\n");
		@FClose($file);
	}

	//If loging by nick is enabled log to file by nick name
	IF(EregI("%logfilenick%", $log)) {
		$write = EregI_Replace("%logfileaction%", "", $log);
		$write = EregI_Replace("%logfilenick%", "", $write);
		$file = @FOpen($setup['log_dir'].$nick.".log", "a+");
		@FWrite($file, $write."\r\n");
		@FClose($file);
	}
	RETURN;
}

//---------------------------------------------------------------------
//Print navigation bar in lists
FUNCTION Navigation($page, $pages, $list, $orderby, $filter1, $filter2, $filter3, $filter4) {
	$prew = $page - 1;
	$next = $page + 1;

	IF($list != "setuplist")
		{$filter = "&filter_active=".$filter1."&filter_colum=".$filter2."&filter_type=".$filter3."&filter=".$filter4;}
	ELSE
		{$filter = "&filter_file=".$filter1."&filter_colum=".$filter2."&filter_type=".$filter3."&filter=".$filter4;}
	?>
	<TABLE class="fs8px">
		<TR>
			<TD>
				<?IF($page > 1)
					{?><A href="index.php?<?Print "q=".$list."&page=".$prew."&orderby=".$orderby.$filter;?>"><IMG src="img/back.gif" width=38 hight=32></A><?}
				ELSE
					{?><IMG src="img/space.gif" width=38 height=32><?}?>
			</TD><TD valign="middle" align="center">
				<?
				FOR($i = 1; $pages >= $i; $i++) {
					IF($i != $page)
						{Print " | <A href=\"index.php?q=".$list."&page=".$i."&orderby=".$orderby.$filter."\" class=\"b\">".$i."</A>";}
					ELSE
						{Print " | <FONT class=\"red b\">".$i."</FONT>";}
				}
				?>
				  | 
			</TD><TD>
				<?IF($page < $pages)
					{?><A href="index.php?<?Print "q=".$list."&page=".$next."&orderby=".$orderby.$filter;?>"><IMG src="img/next.gif" width=38 hight=32></A><?}
				ELSE
					{?><IMG src="img/space.gif" width=38 height=32><?}?>
			</TD>
		</TR>
	</TABLE><?
	RETURN;
}

//---------------------------------------------------------------------
//Return true if nick exist
FUNCTION NickExist($nick) {
	$result = MySQL_Query("SELECT nick FROM reglist WHERE nick LIKE '".$_POST['nick']."'");
	IF(0 < MySQL_Num_Rows($result))
		{RETURN TRUE;}
	ELSE
		{RETURN FALSE;}
}

//---------------------------------------------------------------------

FUNCTION PasswordChange($password1, $password2, $nick, $crypted) {
	$result = MySQL_Query("SELECT pwd_change FROM reglist WHERE nick LIKE '$nick'") OR Die(MySQL_Error());
	$row = MySQL_Fetch_Assoc($result);
	IF($row['pwd_change'] == 1) {
		IF($password1 == $password2) {
			IF($crypted)
				{$password1 = CryptPwd($password1);}
			MySQL_Query("UPDATE reglist SET pwd_change = 0, login_pwd = '$password1', pwd_crypt = $crypted WHERE nick LIKE '$nick'") OR Die(MySQL_Error());
			RETURN TRUE;
		}
		ELSE
			{RETURN FALSE;}
	}
	ELSE
		{RETURN FALSE;}
}

//---------------------------------------------------------------------
//Prints orderby arrows in lists table headers
FUNCTION PrintOrderBy($colum, $orderby, $list, $filter1, $filter2, $filter3, $filter4) {
	IF($list == "messages")
		{$filter = "&filter_active=".$filter1."&filter_colum=".$filter2."&filter_type=".$filter3."&filter=".$filter4;}
	ELSEIF($list == "setuplist")
		{$filter = "&filter_file=".$filter1."&filter_colum=".$filter2."&filter_type=".$filter3."&filter=".$filter4;}
	IF($list != "setuplist")
		{$filter = "&filter_active=".$filter1."&filter_colum=".$filter2."&filter_type=".$filter3."&filter=".$filter4;}

	IF($orderby != $colum." ASC")
		{?>&nbsp;<A href="index.php?q=<?Print $list."&orderby=".$colum."%20ASC".$filter;?>"><IMG src="img/asc.gif" width=9 height=8></A><?}
	ELSE
		{?>&nbsp;<IMG src="img/asca.gif" widet=9 height=8><?}

	IF($orderby != $colum." DESC")
		{?><A href="index.php?q=<?Print $list."&orderby=".$colum."%20DESC".$filter;?>"><IMG src="img/desc.gif" width=9 height=8></A><?}
	ELSE
		{?><IMG src="img/desca.gif" widet=9 height=8><?}
	RETURN;
}

//---------------------------------------------------------------------
//Return short type of share (B/KB/MB/GB/TB)
FUNCTION RoundShare($share) {
	IF($share >= 1073741824 * 1024)
		{$share = Number_format($share / (1073741824 * 1024), 2)." TB";}
	ELSEIF($share >= 1073741824)
		{$share = Number_Format($share / 1073741824, 2)." GB";}
	ELSEIF($share >= 1048576)
		{$share = Number_Format($share / 1048576, 2)." MB";}
	ELSEIF($share >= 1024)
		{$share = Number_Format($share / 1024, 2)." KB";}
	ELSE
		{$share = Number_Format($share)." B";}

	RETURN $share;
}

//---------------------------------------------------------------------
//Print message (error|warning|info32|help)
FUNCTION VA_Message($message, $icon) {?>
	<BR><BR>
	<TABLE class="b1 fs12px" width=350>
		<TR>
			<TD class="bg_light center fs9px b" colspan=2>VerliAdmin message</TD>
		</TR><TR>
			<TD class="bg_light center" width=50  height=70><IMG src="img/<?Print $icon;?>.gif" width=32 height=32></TD>
			<TD class="center b bg_light red"><?Print $message;?></TD>
		</TR>
	</TABLE><?
}

//---------------------------------------------------------------------
//Return true if $email string is valid e-mail
FUNCTION ValidateEmail($email) {
	IF(Ereg("^[\'+\\./0-9A-Z^_\`a-z{|}~\-]+@[a-zA-Z0-9_\-]+(\.[a-zA-Z0-9_\-]+){1,4}$", $email))
		{RETURN TRUE;}
	ELSE
		{RETURN FALSE;}
}

//---------------------------------------------------------------------
//Not used now (Used in some older version and maybe will be used in future (Don1t know))
FUNCTION Validate($what, $hash) {
	IF(Md5($what) == $hash)
		{RETURN TRUE;}
	ELSE
		{RETURN FALSE;}
}
?>